// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('BadigoApp', [
    'ionic',
    'starter.services',
    'starter.directives',
    'ionic.contrib.ui.tinderCards',
    'ionic.giphy',
    'firebase',
    'ngCordova',
    'ngStorage',
    'rzModule',
    'angularMoment',
    'ngResource'
])

        .run(function ($ionicPlatform) {
            $ionicPlatform.ready(function () {
                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(true);

                }
                if (window.StatusBar) {
                    // org.apache.cordova.statusbar required
                    StatusBar.styleDefault();
                }
            });
        })
        .run(function (RzSliderOptions) {
            // show ticks for all sliders
            RzSliderOptions.options({
                showTicks: false
            });
        })

        .config(function ($ionicConfigProvider) {
            //$ionicConfigProvider.scrolling.jsScrolling(true);
            $ionicConfigProvider.navBar.alignTitle('center');
            $ionicConfigProvider.views.swipeBackEnabled(false);

            if (ionic.Platform.isAndroid()) {
                $ionicConfigProvider.scrolling.jsScrolling(true);
            }

        })

        .config(function ($stateProvider) {
            //$urlRouterProvider.otherwise('/welcome');

            $stateProvider
                    .state('welcome', {
                        url: '/welcome',
                        templateUrl: 'view/welcome/welcome.html',
                        controller: 'WelcomeController'
                    })
                    .state('home', {
                        url: '/home',
                        abstract: true,
                        templateUrl: 'view/home/home.html'
                    })

                    .state('home.explore', {
                        cache: false,
                        url: '/explore',
                        templateUrl: 'view/explore/explore.html',
                        controller: 'ExploreControler'
                    })

                    .state('home.settings', {
                        url: '/settings',
                        templateUrl: 'view/settings/settings.html',
                        controller: 'SettingsController'
                    })

                    .state('home.profile', {
                        url: '/profile',
                        templateUrl: 'view/profile/profile.html',
                        controller: 'ProfileController'
                    })

                    .state('home.usersettings', {
                        url: '/usersettings',
                        templateUrl: 'view/usersettings/usersettings.html',
                        controller: 'UserSettingsController'
                    })

                    .state('home.matches', {
                        url: '/matches',
                        templateUrl: 'view/matches/matches.html',
                        controller: 'MatchesController'
                    })

                    .state('home.messaging', {
                        url: '/messaging/:id',
                        templateUrl: 'view/messaging/messaging.html',
                        controller: 'MessagingController'
                    });


        })

        .run(function ($rootScope, $state, $localStorage) {
            $rootScope.$state = $state;
            if (typeof $localStorage.uid === "undefined") {
                $state.go("welcome");
            } else {
                $state.go("home.explore");
            }
        });
