angular.module('BadigoApp').controller('MessagingController', function ($rootScope, $scope, $stateParams, $state, $localStorage, $timeout, $ionicModal, $ionicScrollDelegate, $ionicActionSheet, firebase, $firebaseArray, $firebaseObject, $ionicPopup, $cordovaBadge) {

    $scope.data = {
        keyboardClosable: true,
        isNewMatch: true,
        matchId: null,
        chatExist: false,
        uid: $localStorage.uid,
        photo: $localStorage.photo,
        name: $localStorage.name,
        message: null,
        matchedUserPhotos: [],
        matchedUserProfile: null,
        matchedTime: null,
        takeMessageNotification: false,
        userStatus: true
    };

    $scope.data.matchId = $stateParams.id;

    var browser = ionic.Platform.is('browser');

    var refMessage = firebase.database().ref();

    $scope.startChatTest = function () {

        if ($rootScope.rootData.matches.length > 0) {

            $rootScope.rootData.matches.some(function (value, index) {
                //console.log(value);
                //console.log(index);

                if (value.matchId === $scope.data.matchId) {
                    $scope.data.matchedUserPhotos = value.image;
                    return true;
                }
            });

//    refMessage.child("profile_photo").child($scope.data.matchId).once("value")
//            .then(function (profilePic) {
//                $scope.data.matchedUserPhotos = profilePic.val();
//            });
            refMessage.child("user_profile").child($scope.data.matchId).once("value")
                    .then(function (profile) {
                        $scope.data.matchedUserProfile = profile.val();
                    });

            refMessage.child("matches").child($localStorage.uid).child($scope.data.matchId).once("value")
                    .then(function (match) {
                        if (match.val() !== null) {
                            $scope.data.isNewMatch = match.val().isNew;

                            if ($scope.data.isNewMatch) {
                                refMessage.child("matches/" + $scope.data.uid + "/" + $scope.data.matchId + "/isNew").set(false);
                                refMessage.child("matches/" + $scope.data.uid + "/" + $scope.data.matchId + "/timestamp").once("value").then(function (time) {
                                    $scope.data.matchedTime = time.val();
                                });

                                $rootScope.rootData.totalNewMatch = $rootScope.rootData.totalNewMatch - 1;

                                if (window.cordova) {
                                    $cordovaBadge.decrease(1).then(function () {
                                        // You have permission, badge increased.
                                    }, function (err) {
                                        // You do not have permission.
                                    });
                                }
                            }
                        }
                    });
        }

    };

    $scope.$on('matchFinished', function (event, args) {
        $scope.startChatTest();
    });

    $scope.$on('matchRemoved', function (event, args) {
        //console.log("broadcast kaç kere acilior");
        if (args.matchId === $scope.data.matchId) {
            $rootScope.goPage('home.matches', 'back');
        }
    });

    $scope.startChatTest();

    //var viewScroll = $ionicScrollDelegate.$getByHandle('userMessageScroll');

    $scope.scrollBottom = function () {
        $ionicScrollDelegate.scrollBottom(false);
    };

    var chatId = 'chat_' + ($scope.data.uid < $scope.data.matchId ? $scope.data.uid + '_' + $scope.data.matchId : $scope.data.matchId + '_' + $scope.data.uid);

    //$scope.messages = $firebaseArray(refMessage.child("chat_messages").child(chatId).orderByChild("timestamp"));

    /***************    INFINITE SCROLL TEST PART  ***************/
    var messagesRef = refMessage.child("chat_messages").child(chatId);
    var scrollRef = new firebase.util.Scroll(messagesRef, 'timestampNegative');

    $scope.data.timeOffset = 0;
    var offsetRef = firebase.database().ref(".info/serverTimeOffset");
    offsetRef.on("value", function (snap) {
        $scope.data.timeOffset = snap.val();
    });

    // create a synchronized array on scope
    $scope.messages = $firebaseArray(scrollRef);
    // load the first three contacts
    scrollRef.scroll.next(15);

    // This function is called whenever the user reaches the bottom
    $scope.loadMore = function () {
        // load the next contact
        if (scrollRef.scroll.hasNext()) {
            scrollRef.scroll.next(10);
            //console.log($scope.messages);
        } else {
            //console.log("mesaj bitti");
        }

        $scope.$broadcast('scroll.infiniteScrollComplete');
        $scope.$broadcast('scroll.refreshComplete');
    };
    /***************    INFINITE SCROLL TEST PART END  ***************/

    $scope.checkForChatExist = function () {
        if ($scope.data.chatExist) {
            return true;
        } else {

            refMessage.child("chats/" + chatId).once("value")
                    .then(function (snapshot) {
                        var currentChat = snapshot.exists();

                        if (!currentChat) {
                            refMessage.child("chats").child(chatId).set(true);
                            refMessage.child("chat_members").child(chatId).child($scope.data.uid).set(true);
                            refMessage.child("chat_members").child(chatId).child($scope.data.matchId).set(true);
                            refMessage.child("user_chats").child($scope.data.uid).child(chatId).set(true);
                            refMessage.child("user_chats").child($scope.data.matchId).child(chatId).set(true);

                            $scope.data.chatExist = true;

                            //$scope.data.isNewMatch = false;

                        }
                    });

        }
    };

    $timeout(function () {
        $scope.scrollBottom();
    }, 300);

    $scope.messageIsMine = function (userId) {
        return $scope.data.uid === userId;
    };

    $scope.getBubbleClass = function (userId) {
        var classname = 'message-other';
        if ($scope.messageIsMine(userId)) {
            classname = 'message-mine';
        }
        return classname;
    };

    var refMessageNotification = refMessage.child("user_properties").child($scope.data.matchId).child("messages");
    refMessageNotification.off();
    refMessageNotification.on('value', function (messageNotificationSnap) {
        //console.log("TAKEMESAJJ");
        $scope.data.takeMessageNotification = messageNotificationSnap.val();
    });

    var refStatus = refMessage.child("user_status").child($scope.data.matchId);
    refStatus.off();
    refStatus.on('value', function (userStatusSnap) {
        //console.log("cVALUEEEEE");
        $scope.data.userStatus = userStatusSnap.val();
    });

    $scope.sendMessage = function () {
        if (!$scope.data.chatExist)
            $scope.checkForChatExist();

        var fireTime = Date.now() +$scope.data.timeOffset;
        var message = {
            userId: $scope.data.uid,
            body: angular.copy($scope.data.message),
            type: 'text',
            timestamp: firebase.database.ServerValue.TIMESTAMP,
            timestampNegative: -1 * fireTime,
            read: false
        };

        $scope.messages.$add(message).then(function () {
            $scope.scrollBottom();

            if ($scope.data.takeMessageNotification) {
                if ($scope.data.userStatus === false) {
                    $rootScope.sendNewMessageNotification($scope.data.matchedUserProfile.push_token, $scope.data.uid, $scope.data.name + ' says', message.body);
                }
            }
        });

        $scope.data.message = null;
        $scope.data.keyboardClosable = false;
    };

    $scope.messages.$watch(function (event) {
        if (event.event === 'child_added') {
            $scope.scrollBottom();
        }
    });

    window.addEventListener('native.keyboardshow', function (e) {
        $scope.scrollBottom();
    });

    window.addEventListener('native.keyboardhide', function (e) {
        $scope.scrollBottom();
    });

    $scope.focusMessageText = function () {
        if (!$scope.data.keyboardClosable) {
            angular.element(document.querySelector('#type-area'))[0].focus();
        } else {
            angular.element(document.querySelector('#type-area'))[0].blur();
        }
    };

    // Show the action sheet
    $scope.showUserOptions = function () {
        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.close();
        }
        var hideSheet = $ionicActionSheet.show({
            buttons: [
                {text: '<i class="icon ion-android-remove-circle assertive"></i> Unbadi ' + $scope.data.matchedUserProfile.first_name},
                {text: '<i class="icon ion-android-alert assertive"></i> Report ' + $scope.data.matchedUserProfile.first_name},
                {text: '<i class="icon ion-android-person calm"></i> Show ' + $scope.data.matchedUserProfile.first_name + '\'s profile'}
            ],
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            buttonClicked: function (index) {

                if (index === 0) { //unmatch 

                    $ionicPopup.confirm({
                        title: 'Unbadi',
                        template: 'Are you sure you want to remove your badi?',
                        cancelText: 'Cancel',
                        cancelType: 'button-dark',
                        okText: 'OK',
                        okType: 'button-stable'
                    }).then(function (res) {
                        if (res) {

                            refMessage.child($rootScope.rootData.newUser.USER_MATCHES).child($scope.data.uid).child($scope.data.matchId)
                                    .once('value', function (match) {
                                        if (match.val() !== null && match.val().isNew) {
                                            $rootScope.rootData.totalNewMatch = $rootScope.rootData.totalNewMatch - 1;

                                            if (window.cordova) {
                                                $cordovaBadge.decrease(1).then(function () {
                                                    // You have permission, badge increased.
                                                }, function (err) {
                                                    // You do not have permission.
                                                });
                                            }
                                        }
                                    });

                            refMessage.child($rootScope.rootData.newUser.USER_MATCHES).child($scope.data.uid).child($scope.data.matchId).remove();
                            refMessage.child($rootScope.rootData.newUser.USER_MATCHES).child($scope.data.matchId).child($scope.data.uid).remove();

                            refMessage.child($rootScope.rootData.newUser.USER_LIKE_KEY).child($scope.data.uid).child($scope.data.matchId).remove();
                            refMessage.child($rootScope.rootData.newUser.USER_LIKE_KEY).child($scope.data.matchId).child($scope.data.uid).remove();

                            refMessage.child($rootScope.rootData.newUser.CHAT_MEMBERS).child(chatId).child($scope.data.uid).remove();
                            refMessage.child($rootScope.rootData.newUser.CHAT_MEMBERS).child(chatId).child($scope.data.matchId).remove();

                            refMessage.child($rootScope.rootData.newUser.USER_CHATS).child($scope.data.uid).child(chatId).remove();
                            refMessage.child($rootScope.rootData.newUser.USER_CHATS).child($scope.data.matchId).child(chatId).remove();

                            refMessage.child($rootScope.rootData.newUser.CHAT_MESSAGES).child(chatId).remove();

                            refMessage.child($rootScope.rootData.newUser.CHATS).child(chatId).remove();

                            $state.go("home.matches");
                        }
                    });

                } else if (index === 1) { //report

                } else if (index === 2) { //show profile
                    var now = new Date();

                    var userPrfl = $scope.data.matchedUserProfile;
                    var userAge = now.getYear() - new Date(userPrfl.birth).getYear();

                    $scope.data.profileModal = {
                        photos: $scope.data.matchedUserPhotos,
                        first_name: userPrfl.first_name,
                        last_name: userPrfl.last_name,
                        age: userAge,
                        aboutMe: userPrfl.about
                    };

                    $scope.profileModal.show();

                }

                return true;
            }
        });
    };

    $ionicModal.fromTemplateUrl('view/messaging/profiledetail.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.profileModal = modal;
    });

    $scope.closeProfileModal = function () {
        $scope.profileModal.hide();
    };

    $scope.$on("$ionicView.beforeLeave", function (event, data) {
        refMessage.child("chat_messages").child(chatId).orderByChild("read").equalTo(false).once('value', function (unreadSnap) {

            unreadSnap.forEach(function (unread) {
                if (!$scope.messageIsMine(unread.val().userId)) {
                    unread.ref.update({read: true});
                }
            });

        });
    });
});