angular.module('BadigoApp').controller('ProfileController', function ($rootScope, $scope, firebase, $firebaseObject, $firebaseArray, $localStorage, $ionicPopup,
        $cordovaFile, $cordovaCamera, $ionicModal, $ionicActionSheet, $cordovaDatePicker) {

    $rootScope.showLoading();
    $scope.data = {
        user_profile: null,
        photos: [
            $rootScope.rootData.defaultProfilePhoto,
            $rootScope.rootData.defaultProfilePhoto,
            $rootScope.rootData.defaultProfilePhoto,
            $rootScope.rootData.defaultProfilePhoto,
            $rootScope.rootData.defaultProfilePhoto,
            $rootScope.rootData.defaultProfilePhoto
        ],
        genders: [
            {
                name: "Male",
                key: $rootScope.rootData.gender.MALE,
                value: true
            }, {
                name: "Female",
                key: $rootScope.rootData.gender.FEMALE,
                value: true
            }
        ],
        album: {
            albums: [],
            photos: [],
            selected: null,
            photo: null,
            photoIndex: null,
            isChange: false
        }
    };

    var ref = firebase.database().ref();
    var storageRef = firebase.storage().ref();

    $scope.data.user_profile = $firebaseObject(ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child($localStorage.uid));
    $scope.data.photos = $firebaseArray(ref.child($rootScope.rootData.newUser.USER_PROFILE_PHOTO_KEY).child($localStorage.uid));

    $scope.data.user_profile.$loaded().then(function () {
        $rootScope.hideLoading();
    });


    $scope.selectImageType = function (photo, photoIndex) {
        $scope.data.album.isChange = photo.$value !== $rootScope.rootData.defaultProfilePhoto;
        var hideSheet = $ionicActionSheet.show({
            buttons: !$scope.data.album.isChange ? [{text: '<i class="icon ion-social-facebook calm"></i> Facebook Albums'}, {text: '<i class="icon ion-android-camera calm"></i> Device Photos'}] : photoIndex === 0 ? [] : [{text: '<i class="icon ion-checkmark-circled calm"></i> Make Profile Photo'}],
            destructiveText: $scope.data.album.isChange ? '<i class="icon ion-trash-b assertive"></i> Delete Photo' : '',
            titleText: 'Modify your album',
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            destructiveButtonClicked: function () {
                $scope.removeImage(photo, photoIndex);
                return true;
            },
            buttonClicked: function (index) {
                if ($scope.data.album.isChange) {
                    if (index === 0) {
                        var profilePhoto = angular.copy($scope.data.photos[0]);
                        $scope.data.photos[0].$value = $scope.data.photos[photoIndex].$value;
                        $scope.data.photos[photoIndex].$value = profilePhoto.$value;
                        $scope.data.photos.$save(0).then(function (ref) {
                            $localStorage.photo = $scope.data.photos[0].$value;
                            //console.log("photo saved index 0");
                        });
                        $scope.data.photos.$save(photoIndex).then(function (ref) {
                            //console.log("photo saved index " + photoIndex);
                        });
                    }
                } else {
                    if (index === 0) {
                        //facebook
                        $scope.data.album.photo = photo;
                        $scope.data.album.photoIndex = photoIndex;

                        facebookConnectPlugin.getLoginStatus(function (data) {
                            facebookConnectPlugin.api("me/albums?fields=id,name,cover_photo,count,created_time&limit=50", ["user_photos"],
                                    function (profileResult) {
                                        if (typeof profileResult.data !== "undefined" && profileResult.data !== null) {
                                            $scope.data.album.albums = profileResult.data;
                                            for (var i = 0; i < $scope.data.album.albums.length; i++) {
                                                $scope.data.album.albums[i].coverPhoto = $rootScope.rootData.defaultAlbumCoverPhoto;
                                            }
                                            $scope.coverPhotoWithPromise($scope.data.album.albums.length - 1);
                                            $scope.openAlbumModal();
                                        } else {
                                            $ionicPopup.alert({
                                                title: 'Facebook Album Error',
                                                template: "You don't have any facebook albums.",
                                                okType: 'button-assertive',
                                                okText: 'OK'
                                            });
                                        }
                                    },
                                    function (profileError) {
                                        $ionicPopup.alert({
                                            title: 'Facebook Album Error',
                                            template: "Error while getting facebook albums, Please try again.",
                                            okType: 'button-assertive',
                                            okText: 'OK'
                                        });
                                    });
                        }, function (error) {
                            $ionicPopup.alert({
                                okText: 'OK',
                                okType: 'button-assertive',
                                title: 'Facebook Login Error',
                                template: 'Error while getting facebook login status, Please try again.'
                            });
                        });
                    } else if (index === 1) {
                        //Device
                        $scope.selectNewImage(photo, photoIndex);
                    }
                }
                return true;
            }
        });
    };

    $scope.coverPhotoWithPromise = function (currentIndex) {
        if (currentIndex > -1) {
            facebookConnectPlugin.api($scope.data.album.albums[currentIndex].id + "/picture?debug=all&format=json&method=get&pretty=0&redirect=false&suppress_http_code=1&type=album", ["user_photos"],
                    function (coverResult) {
                        //album.coverPhoto
                        //console.log(coverResult.data.url);
                        $scope.$apply(function () {
                            $scope.data.album.albums[currentIndex].coverPhoto = coverResult.data.url;
                        });
                        currentIndex--;
                        $scope.coverPhotoWithPromise(currentIndex);
                    },
                    function (coverError) {
                        //console.log(coverError);
                        currentIndex--;
                        $scope.coverPhotoWithPromise(currentIndex);
                    });
        }
    };

    $scope.selectAlbum = function (album) {
        $scope.data.album.selected = album;
        facebookConnectPlugin.api(album.id + "/photos?fields=name,source,id&limit=50", ["user_photos"],
                function onSuccess(photoResult) {
                    //console.log(photoResult.data)
                    var photos = photoResult.data;
                    if (typeof photos !== "undefined" && photos !== null && photos.length > 0) {
                        $scope.data.album.photos = photos;
                        $scope.openAlbumPhotosModal();
                    } else {
                        $ionicPopup.alert({
                            title: 'Facebook Album Photo Error',
                            template: "Error while getting photos from selected album.",
                            okType: 'button-assertive',
                            okText: 'OK'
                        }).then(function () {
                            $scope.closeAlbumModal();
                        });
                    }
                },
                function onError(photoError) {
                    $ionicPopup.alert({
                        title: 'Facebook Album Photo Error',
                        template: "Error while getting photos from selected album.",
                        okType: 'button-assertive',
                        okText: 'OK'
                    }).then(function () {
                        $scope.closeAlbumModal();
                    });
                });
    };

    $scope.selectFacebookImage = function (src) {
        /*$rootScope.showLoading();
         //console.log(src, $scope.data.album.photo, $scope.data.album.photoIndex);
         $scope.data.album.photo.$value = src;
         if ($scope.data.album.photoIndex === 0) {
         $localStorage.photo = $scope.data.album.photo.$value;
         }
         $scope.data.photos.$save($scope.data.album.photo).then(function (ref) {
         $rootScope.hideLoading();
         $scope.closeAlbumPhotosModal();
         $scope.closeAlbumModal();
         }, function (error) {
         $rootScope.hideLoading();
         //console.log("Error:", error);
         });*/
        var xhr = new XMLHttpRequest();
        xhr.responseType = 'blob';
        xhr.onload = function (event) {
            var blob = xhr.response;
            $scope.fileUploadProcess($scope.data.album.photo, $scope.data.album.photoIndex, blob);
            $scope.closeAlbumPhotosModal();
            $scope.closeAlbumModal();
        };
        xhr.onError = function () {
            $ionicPopup.alert({
                okText: 'OK',
                okType: 'button-assertive',
                title: 'Photo Select Error',
                template: 'Error while saving facebook photo.'
            });
        };
        xhr.open('GET', src);
        xhr.send();
    };


    $scope.selectNewImage = function (photo, index) {
        $cordovaCamera.getPicture({
            quality: 80,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: Camera.MediaType.PICTURE,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 640,
            targetHeight: 640,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation: true
        }).then(function (imageData) {
            var fullPath = imageData;
            var pathArr = fullPath.split("/");
            var filename = pathArr[pathArr.length - 1];
            filename = filename.split("?")[0];
            var path = fullPath.replace(filename, "");
            $cordovaFile.readAsArrayBuffer(path, filename)
                    .then(function (success) {
                        $scope.fileUploadProcess(photo, index, success);
                    }, function (error) {
                        $ionicPopup.alert({
                            okText: 'OK',
                            okType: 'button-assertive',
                            title: 'Photo Read Error',
                            template: 'Error while reading photo, Please try again.'
                        });
                    });
        }, function (err) {
            // error
        });
    };

    $scope.fileUploadProcess = function (photo, index, data) {
        $rootScope.showLoading();
        var uploadTask = storageRef.child($localStorage.uid).child(index.toString()).put(data, {
            contentType: 'image/jpeg',
        });
        uploadTask.on('state_changed', function (snapshot) {
            // Observe state change events such as progress, pause, and resume
            // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
            var progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
            ////console.log('Upload is ' + progress + '% done');
            switch (snapshot.state) {
                case firebase.storage.TaskState.PAUSED: // or 'paused'
                    ////console.log('Upload is paused');
                    break;
                case firebase.storage.TaskState.RUNNING: // or 'running'
                    ////console.log('Upload is running');
                    break;
            }
        }, function (error) {
            $rootScope.hideLoading();
            //console.log(error);
            $ionicPopup.alert({
                okText: 'OK',
                okType: 'button-assertive',
                title: 'Photo Upload Error',
                template: 'Error while uploading photo, Please try again.'
            });
        }, function () {
            $rootScope.hideLoading();
            // Handle successful uploads on complete
            // For instance, get the download URL: https://firebasestorage.googleapis.com/...
            photo.$value = uploadTask.snapshot.downloadURL;
            if (index === 0) {
                $localStorage.photo = photo.$value;
            }
            $scope.data.photos.$save(photo);
        });
    }

    $scope.refreshLikes = function () {
        $rootScope.showLoading();
        facebookConnectPlugin.getLoginStatus(function (data) {
            facebookConnectPlugin.api("me?fields=id,likes", ["user_likes"],
                    function (likesResult) {
                        $rootScope.hideLoading();
                        if (typeof likesResult.likes !== "undefined") {
                            var likesArr = likesResult.likes.data;
                            $scope.data.user_profile.likes = [];
                            for (var i = 0; i < likesArr.length; i++) {
                                $scope.data.user_profile.likes.push({
                                    id: likesArr[i].id,
                                    name: likesArr[i].name
                                });
                            }
                            $scope.data.user_profile.$save();
                        }
                        //console.log(likesResult);
                    },
                    function (likesError) {
                        $rootScope.hideLoading();
                        $ionicPopup.alert({
                            title: 'Facebook Interests Error',
                            template: "Error while getting facebook interests, Please try again.",
                            okType: 'button-assertive',
                            okText: 'OK'
                        });
                    });
        }, function (error) {
            $rootScope.hideLoading();
            $ionicPopup.alert({
                okText: 'OK',
                okType: 'button-assertive',
                title: 'Facebook Login Error',
                template: 'Error while getting facebook login status, Please try again.'
            });
        });
    };

    $scope.removeImage = function (photo, index) {
        $ionicPopup.confirm({
            title: 'Remove Photo',
            template: 'Are you sure you want to remove this photo?',
            cancelText: 'Cancel',
            cancelType: 'button-dark',
            okText: 'OK',
            okType: 'button-stable'
        }).then(function (res) {
            if (res) {
                if (photo.$value.search("firebasestorage")) {
                    storageRef.child($localStorage.uid).child(index.toString()).delete().then(function () {
                        // File deleted successfully
                    }).catch(function (error) {
                        // Uh-oh, an error occurred!
                    });
                }
                photo.$value = $rootScope.rootData.defaultProfilePhoto;
                $scope.data.photos.$save(photo);
            }
        });

    };

    $scope.showDatePicker = function () {
        $cordovaDatePicker.show({
            date: new Date($scope.data.user_profile.birth),
            mode: 'date', // or 'time'
            //minDate: new Date() - 10000,
            maxDate: new Date(),
            allowOldDates: true,
            allowFutureDates: false,
            doneButtonLabel: 'DONE',
            doneButtonColor: '#4685dd',
            cancelButtonLabel: 'CANCEL',
            cancelButtonColor: '#000000'
        }).then(function (date) {
            $scope.data.user_profile.birth = date.getTime();
        });
    };

    /************************About Me Modal*************************/
    $ionicModal.fromTemplateUrl('view/profile/aboutme.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.aboutMeModal = modal;
    });
    $scope.openAboutMeModal = function () {
        $scope.aboutMeModal.show();
    };
    $scope.closeAboutMeModal = function () {
        $scope.aboutMeModal.hide();
    };

    /************************My Gender Modal*************************/
    $ionicModal.fromTemplateUrl('view/profile/mygender.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.myGenderModal = modal;
    });

    $scope.openMyGenderModal = function () {
        $scope.myGenderModal.show();
    };
    $scope.closeMyGenderModal = function () {
        $scope.myGenderModal.hide();
    };


    /************************Facebook Album Modal*************************/
    $ionicModal.fromTemplateUrl('view/profile/album.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.albumModal = modal;
    });
    $scope.openAlbumModal = function () {
        $scope.albumModal.show();
    };
    $scope.closeAlbumModal = function () {
        $scope.data.album.albums = [];
        $scope.data.album.photo = null;
        $scope.data.album.photoIndex = null;
        if ($scope.albumModal.isShown()) {
            $scope.albumModal.hide();
        }
    };

    /************************Facebook Album Photos Modal*************************/
    $ionicModal.fromTemplateUrl('view/profile/albumphotos.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function (modal) {
        $scope.albumPhotosModal = modal;
    });
    $scope.openAlbumPhotosModal = function () {
        $scope.albumPhotosModal.show();
    };
    $scope.closeAlbumPhotosModal = function () {
        $scope.data.album.photos = [];
        $scope.data.album.selected = null;
        if ($scope.albumPhotosModal.isShown()) {
            $scope.albumPhotosModal.hide();
        }
    };



    $scope.$on('$destroy', function () {
        $scope.aboutMeModal.remove();
        $scope.myGenderModal.remove();
        $scope.albumModal.remove();
        $scope.albumPhotosModal.remove();
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        $scope.data.user_profile.$save();
    });


});