angular.module('BadigoApp').controller('WelcomeController', function ($rootScope, $scope, $state, $firebaseAuth, $ionicPopup, $localStorage, firebase, $cordovaGeolocation, PushService) {

    if (typeof $localStorage.uid !== "undefined" && $localStorage.uid !== null) {
        $rootScope.getUserMatches();
//        $rootScope.getUserChats();
        //console.log("welcomedan cagrıldı");
        $state.go("home.explore");
    }

    $scope.data = {
        newUser: {
            user_profile: {
                email: "",
                gender: null,
                about: "",
                work: "",
                school: "",
                first_name: "",
                last_name: "",
                birth: 0,
                push_token: null,
                likes: []
            },
            user_properties: {
                max_distance: 80,
                gender: [],
                min_age: 18,
                max_age: 35,
                username: "",
                new_match: true,
                message_like: true,
                messages: true,
                super_likes: true,
                vibration: true,
                location: null
            },
            location: {
                lat: 0,
                lon: 0,
                city: "",
                country: ""
            },
            profile_photo: [
                $rootScope.rootData.defaultProfilePhoto,
                $rootScope.rootData.defaultProfilePhoto,
                $rootScope.rootData.defaultProfilePhoto,
                $rootScope.rootData.defaultProfilePhoto,
                $rootScope.rootData.defaultProfilePhoto,
                $rootScope.rootData.defaultProfilePhoto
            ]
        }
    };

    var ref = firebase.database().ref();
    var geoFire = new GeoFire(ref.child($rootScope.rootData.newUser.USER_LOCATOIN_KEY));

    $scope.fbLogin = function () {
        $scope.findLocation();
        var browser = ionic.Platform.is('browser');
        var auth = $firebaseAuth();
        if (browser) {
            auth.$signInWithPopup("facebook").then(function (firebaseUser) {
                //console.log("Signed in as:", firebaseUser.user);
                if (typeof $localStorage.uid === "undefined" || $localStorage.uid === null) {
                    $scope.data.newUser.user_profile.first_name = firebaseUser.user.displayName;
                    $scope.data.newUser.user_profile.email = firebaseUser.user.email;
                    $scope.data.newUser.profile_photo[0] = firebaseUser.user.photoURL;

                    ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY + "/" + firebaseUser.user.uid)
                            .once('value', function (prof) {
                                if (prof.val() === null) {
                                    $scope.createUser(firebaseUser.user.uid);
                                } else {
                                    $scope.loadUser(firebaseUser.user.uid);
                                }
                            });
                } else {
                    $rootScope.getUserMatches();
//                    $rootScope.getUserChats();
                    //console.log("welcomedan cagrıldı");
                    $state.go("home.explore");
                }
            }).catch(function (error) {
                //console.log("Authentication failed:", error);
                $ionicPopup.alert({
                    okText: 'OK',
                    okType: 'button-assertive',
                    title: 'Authentication Failed',
                    template: 'Facebook authentication is not successfull. Please try again.'
                });
            });
        } else {
            if (typeof $localStorage.uid === "undefined" || $localStorage.uid === null) {
                facebookConnectPlugin.login(["public_profile", "email", "user_birthday", "user_photos", "user_likes"],
                        function (data) {
                            facebookConnectPlugin.api("me/?fields=email,first_name,last_name,gender,birthday,albums,likes.limit(100)", ["public_profile", "email", "user_birthday", "user_photos", "user_likes"],
                                    function onSuccess(profileResult) {
                                        //console.log(profileResult);

                                        $scope.data.newUser.user_profile.birth = new Date(profileResult.birthday).getTime();
                                        $scope.data.newUser.user_profile.email = profileResult.email;
                                        $scope.data.newUser.user_profile.first_name = profileResult.first_name;
                                        $scope.data.newUser.user_profile.last_name = profileResult.last_name;
                                        $scope.data.newUser.user_profile.gender = profileResult.gender;

                                        if (typeof profileResult.likes !== "undefined") {
                                            var likesArr = profileResult.likes.data;
                                            for (var i = 0; i < likesArr.length; i++) {
                                                $scope.data.newUser.user_profile.likes.push({
                                                    id: likesArr[i].id,
                                                    name: likesArr[i].name
                                                });
                                            }
                                        }

                                        if (profileResult.gender === $rootScope.rootData.gender.MALE) {
                                            $scope.data.newUser.user_properties.gender = [$rootScope.rootData.gender.FEMALE];
                                            $scope.getProfilePhotos(data, profileResult);
                                        } else if (profileResult.gender === $rootScope.rootData.gender.FEMALE) {
                                            $scope.data.newUser.user_properties.gender = [$rootScope.rootData.gender.MALE];
                                            $scope.getProfilePhotos(data, profileResult);
                                        } else {
                                            $ionicPopup.show({
                                                templateUrl: 'view/welcome/genderforce.html',
                                                title: 'Select Your Gender',
                                                subTitle: "Please select your gender, this value doesn't change in the future",
                                                scope: $scope,
                                                buttons: [
                                                    {
                                                        text: '<b>OK</b>',
                                                        type: 'button-positive',
                                                        onTap: function (e) {
                                                            if (!$scope.data.newUser.user_profile.gender) {
                                                                //console.log($scope.data.newUser.user_profile.gender);
                                                                e.preventDefault();
                                                            } else {
                                                                //console.log($scope.data.newUser.user_profile.gender);
                                                                if ($scope.data.newUser.user_profile.gender === $rootScope.rootData.gender.MALE) {
                                                                    $scope.data.newUser.user_properties.gender = [$rootScope.rootData.gender.FEMALE];
                                                                } else if ($scope.data.newUser.user_profile.gender === $rootScope.rootData.gender.FEMALE) {
                                                                    $scope.data.newUser.user_properties.gender = [$rootScope.rootData.gender.MALE];
                                                                }
                                                                $scope.getProfilePhotos(data, profileResult);
                                                                return $scope.data.newUser.user_profile.gender;
                                                            }
                                                        }
                                                    }
                                                ]
                                            });
                                        }



                                    },
                                    function onError(profileError) {
                                        $ionicPopup.alert({
                                            title: 'Facebook Error',
                                            template: "Facebook authentication is not successfull. Please try again.",
                                            okType: 'button-assertive',
                                            okText: '<b>OK</b>'
                                        });
                                    });

                        },
                        function (error) {
                            //console.log(error)
                            $ionicPopup.alert({
                                title: 'Facebook Error',
                                template: "Facebook authentication is not successfull. Please try again.",
                                okType: 'button-assertive',
                                okText: '<b>OK</b>'
                            });
                        });
            } else {
                $rootScope.getUserMatches();
                //$rootScope.getUserChats();
                //console.log("welcomedan cagrıldı");
                $state.go("home.explore");
            }
        }

    };

    $scope.authWithCredentials = function (creadentials) {
        $firebaseAuth().$signInWithCredential(creadentials).then(function (firebaseUser) {
            //console.log("Signed in as:", firebaseUser.uid);
            ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY + "/" + firebaseUser.uid)
                    .once('value', function (prof) {
                        try {
                            FCMPlugin.getToken(
                                    function (token) {
                                        //console.log("Device Token: " + token);
                                        $localStorage.pushToken = token;
                                        $scope.data.newUser.user_profile.push_token = $localStorage.pushToken;

                                        if (prof.val() === null) {
                                            $scope.createUser(firebaseUser.uid);
                                        } else {
                                            ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child(firebaseUser.uid).update({push_token: $localStorage.pushToken});
                                            $scope.loadUser(firebaseUser.uid);
                                        }
                                    },
                                    function (err) {
                                        //console.log('error retrieving token: ' + err);
                                    });
                        } catch (err) {
                            //console.log('error fcm plugin: ' + err);
                        }
                    });
        }).catch(function (error) {
            //console.log("Authentication failed:", error);
            $ionicPopup.alert({
                okText: 'OK',
                okType: 'button-assertive',
                title: 'Authentication Failed',
                template: 'Authentication is not successfull. Please try again later.'
            });
        });
    };

    $scope.getProfilePhotos = function (data, profileResult) {
        var profilePicturesObject = null;
        if (typeof profileResult.albums !== "undefined" && typeof profileResult.albums.data !== "undefined" && profileResult.albums.data !== null) {
            var albums = profileResult.albums.data;
            for (var i = 0; i < albums.length; i++) {
                var currentAlbum = albums[i];
                if (currentAlbum.name === "Profile Pictures") {
                    profilePicturesObject = currentAlbum;
                    break;
                }
            }

            if (profilePicturesObject !== null) {
                facebookConnectPlugin.api(profilePicturesObject.id + "/photos?fields=name,source,id&limit=6", ["user_photos"],
                        function onSuccess(photoResult) {
                            //console.log(photoResult.data)
                            var photos = photoResult.data;
                            if (typeof photos !== "undefined" && photos !== null && photos.length > 0) {
                                for (var j = 0; j < photos.length; j++) {
                                    $scope.data.newUser.profile_photo[j] = photos[j].source;
                                }
                            }
                            $scope.authWithCredentials(firebase.auth.FacebookAuthProvider.credential(data.authResponse.accessToken));
                        },
                        function onError(photoError) {
                            $scope.authWithCredentials(firebase.auth.FacebookAuthProvider.credential(data.authResponse.accessToken));
                            /*$ionicPopup.alert({
                             title: 'Facebook Hatası',
                             template: "Facebook foto albümü getirme sırasında hata meydana geldi.",
                             okType: 'button-assertive',
                             okText: 'Tamam'
                             });*/
                        });
            } else {
                //console.log("Profil albümü bulunamadı, giriş yapıldı.");
                $scope.authWithCredentials(firebase.auth.FacebookAuthProvider.credential(data.authResponse.accessToken));
            }


        } else {
            //console.log("herhangi bir albüm bulunamadı, giriş yapıldı.");
            $scope.authWithCredentials(firebase.auth.FacebookAuthProvider.credential(data.authResponse.accessToken));
        }
    }

    $scope.loadUser = function (uid) {
        geoFire.set(uid, [$scope.data.newUser.location.lat, $scope.data.newUser.location.lon]).then(function () {
            ref.child($rootScope.rootData.newUser.USER_PROFILE_PHOTO_KEY + "/" + uid)
                    .once('value', function (photoSnap) {
                        var photos = photoSnap.val();
                        $rootScope.hideLoading();
                        $localStorage.uid = uid;
                        $localStorage.photo = photos[0];
                        $localStorage.name = $scope.data.newUser.user_profile.first_name;
                        ref.child("user_status").child(uid).set(true);
                        $rootScope.getUserMatches();
//                        $rootScope.getUserChats();
                        //console.log("welcomedan cagrıldı");
                        $state.go("home.explore");
                    });

        }, function (error) {
            ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child(uid).remove();
            ref.child($rootScope.rootData.newUser.USER_PROPERTIES_KEY).child(uid).remove();
            $rootScope.hideLoading();
            $ionicPopup.alert({
                okText: 'OK',
                okType: 'button-assertive',
                title: 'Loading Account Error',
                template: 'Error while loading account, please try again later.'
            });
        });
    };



    $scope.createUser = function (uid) {
        $rootScope.showLoading();

        ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child(uid).set($scope.data.newUser.user_profile, function (error) {
            if (error) {
                $rootScope.hideLoading();
                $ionicPopup.alert({
                    okText: 'OK',
                    okType: 'button-assertive',
                    title: 'Creating Account Error',
                    template: 'Error while creating account, please try again later.'
                });
            } else {
                ref.child($rootScope.rootData.newUser.USER_PROPERTIES_KEY).child(uid).set($scope.data.newUser.user_properties, function (error) {
                    if (error) {
                        ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child(uid).remove();
                        $rootScope.hideLoading();
                        $ionicPopup.alert({
                            okText: 'OK',
                            okType: 'button-assertive',
                            title: 'Creating Account Error',
                            template: 'Error while creating account, please try again later.'
                        });
                    } else {
                        geoFire.set(uid, [$scope.data.newUser.location.lat, $scope.data.newUser.location.lon]).then(function () {
                            $scope.uploadToFirebase(0, uid);
                        }, function (error) {
                            ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child(uid).remove();
                            ref.child($rootScope.rootData.newUser.USER_PROPERTIES_KEY).child(uid).remove();
                            $rootScope.hideLoading();
                            $ionicPopup.alert({
                                okText: 'OK',
                                okType: 'button-assertive',
                                title: 'Creating Account Error',
                                template: 'Error while creating account, please try again later.'
                            });
                        });
                    }
                });
            }
        });


    };

    var storageRef = firebase.storage().ref();
    $scope.uploadToFirebase = function (index, uid) {
        if (index < 6) {
            if ($scope.data.newUser.profile_photo[index] === $rootScope.rootData.defaultProfilePhoto) {
                $scope.uploadToFirebase(index + 1, uid);
            } else {
                var xhr = new XMLHttpRequest();
                var src = angular.copy($scope.data.newUser.profile_photo[index]);
                xhr.responseType = 'blob';
                xhr.onload = function (event) {
                    var blob = xhr.response;
                    var contentType = xhr.getResponseHeader("content-type");
                    if (typeof contentType === "undefined" || contentType === null || contentType === "") {
                        contentType = 'image/jpeg';
                    }
                    var photoStorageRef = storageRef.child(uid).child(index.toString());
                    photoStorageRef.put(blob, {
                        contentType: contentType
                    }).then(function (snapshot) {
                        $scope.data.newUser.profile_photo[index] = snapshot.downloadURL;
                        $scope.uploadToFirebase(index + 1, uid);
                    });
                };
                xhr.onError = function () {
                    $scope.uploadToFirebase(index + 1, uid);
                };
                xhr.open('GET', src);
                xhr.send();

            }
        } else {
            ref.child($rootScope.rootData.newUser.USER_PROFILE_PHOTO_KEY).child(uid).set($scope.data.newUser.profile_photo, function (error) {
                if (error) {
                    ref.child($rootScope.rootData.newUser.USER_PROFILE_KEY).child(uid).remove();
                    ref.child($rootScope.rootData.newUser.USER_PROPERTIES_KEY).child(uid).remove();
                    geoFire.remove(uid).then(function () {
                        //console.log("Provided key has been removed from GeoFire");
                    }, function (error) {
                        //console.log("Error: " + error);
                    });

                    $rootScope.hideLoading();
                    $ionicPopup.alert({
                        okText: 'OK',
                        okType: 'button-assertive',
                        title: 'Creating Account Error',
                        template: 'Error while creating account, please try again later.'
                    });
                } else {
                    $rootScope.hideLoading();
                    $localStorage.uid = uid;
                    $localStorage.photo = $scope.data.newUser.profile_photo[0];
                    $localStorage.name = $scope.data.newUser.user_profile.first_name;
                    ref.child("user_status").child(uid).set(true);
                    $rootScope.getUserMatches();
//                                    $rootScope.getUserChats();
                    //console.log("welcomedan cagrıldı");
                    $state.go("home.explore");
                }
            });
        }
    }

    $scope.findLocation = function () {
        $cordovaGeolocation
                .getCurrentPosition($rootScope.rootData.geolocationOptions)
                .then(function (position) {
                    $scope.data.newUser.location.lat = position.coords.latitude;
                    $scope.data.newUser.location.lon = position.coords.longitude;
                    $scope.getLocationName();

                    //console.log(position);
                }, function (err) {
                    $scope.data.newUser.location.lat = $rootScope.rootData.defaultCoords.lat;
                    $scope.data.newUser.location.lon = $rootScope.rootData.defaultCoords.lon;
                });
    }


    $scope.getLocationName = function () {
        if ($scope.data.location !== null) {
            PushService.geocode().translate({
                latlng: $scope.data.newUser.location.lat + "," + $scope.data.newUser.location.lon
            }, function (data) {
                var adress = data.results[0].address_components;
                var adressStr = $rootScope.findAdressFromGoogleResult(adress);
                $scope.data.newUser.user_properties.location = adressStr;
                //$scope.data.newUser.user_properties.location = adress[5].short_name + ", " + adress[4].short_name + ", " + adress[3].short_name;
            }, function (err) {
                //console.log(err);
            });
        }
    };


});